//
//  RegisterViewController.m
//  butterflyradio
//
//  Created by Denny Kwon on 6/7/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "RegisterViewController.h"

@implementation UITextField (UITextFieldCategory)
+ (UITextField *)textFieldwithFrame:(CGRect)frame placeholder:(NSString *)p
{
    UITextField *textField = [[UITextField alloc] initWithFrame:frame];
    textField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
    textField.borderStyle = UITextBorderStyleNone;
    textField.placeholder = p;
    textField.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
    return [textField autorelease];
}
@end

@interface RegisterViewController ()
@property (retain, nonatomic) BRTextBox *descriptionBox;
@end

@implementation RegisterViewController
@synthesize nameField;
@synthesize emailField;
@synthesize emailHost;
@synthesize delegate;


- (id)initWithManager:(ButterflyManager *)mgr
{
    self = [super initWithManager:mgr];
    if (self) {
        clearCookies = TRUE;
        self.title = @"Register";
    }
    return self;
}



- (void)dealloc
{
    if (clearCookies==TRUE){
        NSArray *cookies = [NSHTTPCookieStorage sharedHTTPCookieStorage].cookies;
        for(NSHTTPCookie *cookie in cookies) {
            [[NSHTTPCookieStorage sharedHTTPCookieStorage] deleteCookie:cookie];
        }
    }
    
    self.delegate = nil;
    self.descriptionBox = nil;
    [nameField release];
    [emailField release];
    [emailHost release];
    [super dealloc];
}


- (void)loadView
{
    UIView *view = [self baseViewWithColor:[UIColor colorWithRed:0.90f green:0.90f blue:0.90f alpha:1.0f]];
    CGRect frame = view.frame;
    
    self.descriptionBox = [[[BRTextBox alloc] initWithFrame:CGRectMake(20.0f, 85.0f, frame.size.width-40.0f, 10.0f)] autorelease];
    NSString *text = [NSString stringFromFile:@"register.txt"];
    text = [text stringByReplacingOccurrencesOfString:@"{{APP NAME}}" withString:self.butterflyMgr.appName];
    self.descriptionBox.lblText.text = text;
    self.descriptionBox.lblTitle.text = @"Sign Up";
    [view addSubview:self.descriptionBox];
    
    CGFloat h = 35.0f;
    CGFloat w = 145.0f;
    UIButton *btnRegister = [UIButton buttonWithType:UIButtonTypeCustom];
    btnRegister.autoresizingMask = UIViewAutoresizingFlexibleTopMargin;
    btnRegister.frame = CGRectMake(10, view.frame.size.height-h-15, w, h);
    [btnRegister addTarget:self action:@selector(registerBtnPressed:) forControlEvents:UIControlEventTouchUpInside];
    [btnRegister setBackgroundImage:[UIImage imageNamed:@"btn_base_gray@2x.png"] forState:UIControlStateNormal];
    [btnRegister setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [btnRegister setTitle:@"Register" forState:UIControlStateNormal];
    btnRegister.titleLabel.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
    btnRegister.showsTouchWhenHighlighted = YES;
    [view addSubview:btnRegister];

    UIButton *btnAppstore = [UIButton buttonWithType:UIButtonTypeCustom];
    btnAppstore.autoresizingMask = UIViewAutoresizingFlexibleTopMargin;
    btnAppstore.frame = CGRectMake(165, view.frame.size.height-h-15, w, h);
    [btnAppstore addTarget:self action:@selector(appstoreBtnPressed:) forControlEvents:UIControlEventTouchUpInside];
    [btnAppstore setBackgroundImage:[UIImage imageNamed:@"btn_base_gray@2x.png"] forState:UIControlStateNormal];
    [btnAppstore setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [btnAppstore setTitle:@"Butterfly Radio" forState:UIControlStateNormal];
    btnAppstore.titleLabel.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
    btnAppstore.showsTouchWhenHighlighted = YES;
    [view addSubview:btnAppstore];

    
    self.view = view;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setUpBackButton:self action:@selector(exit)];

    DetailBackground *nameBg = [DetailBackground backgroundWithFrame:CGRectMake(0, 0, 320, 35)];
    [nameBg.btnLabel setTitle:@"Name" forState:UIControlStateNormal];
    self.nameField = [UITextField textFieldwithFrame:CGRectMake(80, 5, 225, 25) placeholder:@"name"];
    nameField.borderStyle = UITextBorderStyleNone;
    nameField.delegate = self;
    [nameBg addSubview:nameField];
    [self.view addSubview:nameBg];
    
    DetailBackground *emailBg = [DetailBackground backgroundWithFrame:CGRectMake(0, 35, 320, 35)];
    [emailBg.btnLabel setTitle:@"Email" forState:UIControlStateNormal];
    self.emailField = [UITextField textFieldwithFrame:CGRectMake(80, 5, 225, 25) placeholder:@"email"];
    emailField.borderStyle = UITextBorderStyleNone;
    emailField.userInteractionEnabled = NO;
    emailField.textColor = [UIColor grayColor];
    [emailBg addSubview:emailField];
    [self.view addSubview:emailBg];
    
    UIImage *shadow = [UIImage imageNamed:@"dropShadow.png"];
    UIImageView *dropShadow = [[UIImageView alloc] initWithImage:shadow];
    dropShadow.frame = CGRectMake(0, emailBg.frame.origin.y+emailBg.frame.size.height, shadow.size.width, shadow.size.height);
    [self.view addSubview:dropShadow];
    [dropShadow release];

    [self setupLoadingIndicator];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return TRUE;
}

- (void)exit
{
    [self.navigationController popViewControllerAnimated:YES];
}

- (IBAction)registerBtnPressed:(UIButton *)btn
{
    NSLog(@"registerBtnPressed:");
    if ([nameField.text length]==0){
        [self showAlert:@"Missing Value" message:@"Please enter your name in the name field."];
        return;
    }
    
    
    if (self.request != nil){
        [self.request cancel];
        self.request.delegate = nil;
        self.request = nil;
    }
    
    NSString *url = [NSString stringWithFormat:@"http://%@/api/host", kUrl];
    NSDictionary *params = [NSDictionary dictionaryWithObjectsAndKeys:emailHost, @"emailhost", [emailField.text lowercaseString], @"email", nameField.text, @"name", @"create", @"action", nil];
    
    self.request = [BRNetworkOp operationWithAddress:url parameters:params];
    self.request.delegate = self;
    [self.request sendRequest];
    [self.loading show];
}

- (IBAction)appstoreBtnPressed:(UIButton *)btn
{
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:kItunesURL]];
}

- (void)requestData:(NSArray *)pkg //returns [address, data]
{
//    NSLog(@"requestData:");
    if (pkg==nil)
        return;
    
    NSDictionary *json = [self.request parseJsonResponse];

    if (!json)
        return;
    
    NSDictionary *d = [json objectForKey:@"results"];
    if (d==nil)
        return;

    [self.loading hide];
    NSLog(@"%@", [d description]);
    NSString *confirmation = [d objectForKey:@"confirmation"];
    if ([confirmation isEqualToString:@"fail"]==FALSE){
        clearCookies = FALSE;
        [delegate registrationComplete];
        [self.navigationController popViewControllerAnimated:NO];
    }
}


#pragma mark - UIResponder Touch Methods
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    NSLog(@"touchesBegan:");
    [self.nameField resignFirstResponder];
}


- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    NSLog(@"touchesCancelled:");
    [self.nameField resignFirstResponder];
}



- (void)viewDidUnload
{
    [super viewDidUnload];
    self.nameField = nil;
    self.emailField = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
