//
//  BRAudioPlayer.h
//  AllThingsComedy
//
//  Created by Denny Kwon on 3/4/13.
//  Copyright (c) 2013 TheGridMedia. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>
#import "BRTrack.h"


@protocol BRAudioPlayerDelegate <NSObject>
- (void)progressUpdate:(double)pct;
@end


@interface BRAudioPlayer : NSObject

@property (assign) id delegate;
@property (nonatomic) BOOL butterflyStation;
@property (retain, nonatomic) NSMutableArray *tracks;
@property (retain, nonatomic) AVPlayer *avPlayer;
@property (retain, nonatomic) BRTrack *currentTrack;
@property (retain, nonatomic) NSTimer *playbackTimer;
+ (BRAudioPlayer *)audioPlayer;
- (void)start:(int)index;
- (void)reset;
- (BOOL)playPause; // returns YES if playing, NO if paused
- (void)playPreviousTrack;
- (void)playNextTrack;
- (void)pause;
- (void)seek:(double)pct;
- (void)receivedRemoteControlEvent:(UIEvent *)event;
@end
