//
//  BRStreamer.h
//  AudioPlayer
//
//  Created by Denny Kwon on 12/26/12.
//  Copyright (c) 2012 com.thegridmedia. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>
#import <UIKit/UIKit.h>
#import "BRTrack.h"
#import "Globals.h"

@protocol StreamerDelegate
//- (void)changePlayState;
- (void)fileFinished;
- (void)playbackStarted;
- (void)updateProgress:(double)pct;
@end


@interface BRStreamer : NSObject

@property (readwrite) AudioFileStreamID fileStream;
@property (readwrite) AudioQueueRef queue;
@property (retain, nonatomic) BRTrack *source;
@property (assign) id delegate;
@property (nonatomic) unsigned long totalBytesPlayed;
@property (nonatomic) int bufferCount;
@property (nonatomic) int callbackCount;
@property (nonatomic) int index;
@property (nonatomic) BOOL isRunning;
@property (nonatomic) BOOL flushing;
@property (nonatomic) BOOL readyToAcceptPackets;
@property (retain, nonatomic) NSArray *tracks;
@property (retain, nonatomic) NSTimer *timer;
@property (nonatomic) UInt64 processedPacketsCount;		// number of packets accumulated for bitrate estimation
@property (nonatomic) UInt64 processedPacketsSizeTotal;	// byte size of accumulated estimation packets
+ (BRStreamer *)streamer;
- (void)parseBytes:(NSData *)data;
- (void)seekto:(double)value;
- (void)reset:(BOOL)restart;
- (void)finished;
- (void)clear;
- (void)suspend;

- (void)start;
- (void)pause;
- (void)resume;
- (void)skip;
@end
