//
//  BRNetworkOp.h
//  frenchkiss
//
//  Created by Denny Kwon on 8/21/12.
//  Copyright (c) 2012 Frenchkiss Records. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Reachability.h"
#import "Globals.h"


@protocol BRNetworkOpDelegate <NSObject>
@required
- (void)requestData:(NSArray *)pkg; //returns [address, data]
@optional
- (void)downloadedData:(NSData *)data;
- (void)initialResponse:(NSDictionary *)headers;
- (void)requestError:(NSError *)error;
@end

@interface BRNetworkOp : NSObject

+ (BRNetworkOp *)operationWithAddress:(NSString *)a parameters:(NSDictionary *)p;
- (id)initWithAddress:(NSString *)a parameters:(NSDictionary *)p;
- (id)parseJsonResponse;
- (void)sendRequest;
- (void)setHttpMethod:(NSString *)m;
- (void)clear;
- (void)cancel;
@property (retain, nonatomic) NSMutableURLRequest *urlRequest;
@property (retain, nonatomic) NSMutableData *responseData;
@property (retain, nonatomic) NSURLConnection *urlConnection;
@property (retain, nonatomic) NSString *address;
@property (retain, nonatomic) NSDictionary *responseHeaders;
@property (retain, nonatomic) NSDictionary *requestHeaders;
@property (copy, nonatomic) NSString *requestMethod;
@property (nonatomic) NetworkStatus networkStatus;
@property (assign)id delegate;
@end
