//
//  ButterflyManager.h
//  frenchkiss
//
//  Created by Denny Kwon on 8/19/12.
//  Copyright (c) 2012 Frenchkiss Records. All rights reserved.


#import <Foundation/Foundation.h>
#import <MediaPlayer/MediaPlayer.h>
#import "Globals.h"
#import "BRNetworkOp.h"
#import "Station.h"
#import "BRHost.h"
#import "Database.h"
#import "BRStreamer.h"


@protocol ButterflyDelegate <NSObject>

@end


@interface ButterflyManager : NSObject <BRNetworkOpDelegate> {
    BRNetworkOp *req;
    NSOperationQueue *queue;
}

@property (assign) id delegate;
@property (retain, nonatomic) Database *db;
@property (retain, nonatomic) BRStreamer *streamer;
@property (retain, nonatomic) BRHost *host;
@property (retain, nonatomic) Station *currentStation;
@property (retain, nonatomic) NSMutableDictionary *stations; //contains 2 arrays: host, admin
@property (retain, nonatomic) NSMutableArray *favorites;

// Host App Info
@property (retain, nonatomic) NSString *appBundle;
@property (retain, nonatomic) NSString *appName;
@property (retain, nonatomic) NSString *appVersion;
@property (copy, nonatomic) NSString *appHost;

+ (ButterflyManager *)managerWithAppHost:(NSString *)appHost;
- (void)fetchStations; //fetches all stations of app host
- (void)fetchTopTracks:(int)offset;
- (void)showRadio;
- (void)checkFavorites;
- (void)start:(int)index;
- (void)receivedRemoteControlEvent:(UIEvent *)event;
- (void)searchStations:(BRStationSearchFilter)filter;
- (void)searchStationsByCategory:(NSString *)category;

//player methods:
- (void)loadTrack:(NSIndexPath *)indexPath fromStation:(Station *)station;
- (void)playTrack:(BRTrack *)track fromStation:(Station *)station;
@end
