//
//  ButterflyViewController.h
//  frenchkiss
//
//  Created by Denny Kwon on 8/20/12.
//  Copyright (c) 2012 Frenchkiss Records. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ButterflyManager.h"
#import "Globals.h"
#import "BRNetworkOp.h"
#import "Station.h"
#import "BRHost.h"
#import "LoadingIndicator.h"
#import "SignalCheck.h"
#import <QuartzCore/QuartzCore.h>
#import "UIViewController+BRMethods.h"
#import "NSString+BRMethods.h"
#import "BRToolbar.h"
#import "PurchaseManager.h"
#import "BRTextBox.h"


@interface ButterflyViewController : UIViewController <UIScrollViewDelegate, PurchaseManagerDelegate> {
    
    
    
    //Only for tableviews - not all subclasses will use these:
    UIView *refreshHeaderView;
    UILabel *refreshLabel;
    UIImageView *refreshArrow;
    UIActivityIndicatorView *refreshSpinner;
    BOOL isDragging;
    BOOL isLoading;
    
    BOOL reloadable;
    
}

@property (retain, nonatomic) ButterflyManager *butterflyMgr;
@property (retain, nonatomic) SignalCheck *signal;
@property (retain, nonatomic) LoadingIndicator *loading;
@property (retain, nonatomic) BRNetworkOp *request;
@property (retain, nonatomic) BRTrack *premiumTrack;
@property (retain, nonatomic) PurchaseManager *purhcaseManager;
@property (retain, nonatomic) BRToolbar *bottomToolbar;
@property (nonatomic) CGPoint ptStart;
@property (nonatomic) BOOL isOnTop;

- (id)initWithManager:(ButterflyManager *)mgr;
- (UIView *)baseViewWithColor:(UIColor *)color;

// UI:
- (void)setupNowPlayingButton;
- (void)setUpBackButton:(id)target action:(SEL)action;
- (void)setupLoadingIndicator:(int)color verticalOffset:(CGFloat)y;
- (void)setupLoadingIndicator;

// Transition to other view controllers:
- (void)showAccount;
- (void)showRadio;
- (void)showRadioWithLoader;

- (NSString *)createFilePath:(NSString *)fileName;
- (void)addPullToRefreshHeader:(UIScrollView *)container;
- (void)stopLoading:(UIScrollView *)scrollView;
- (void)showAlert:(NSString *)title message:(NSString *)msg;
- (void)slide;
- (void)launchPurchaseSequence;

// Barbutton helper methods:
- (UIBarButtonItem *)flex;
- (UIBarButtonItem *)barButtonWithImage:(UIImage *)image tag:(int)t;
- (UIBarButtonItem *)barButtonWithText:(NSString *)text tag:(int)t;
- (BRTrackAuthorization)trackAuthorizationStatus:(BRTrack *)track fromStation:(Station *)station;
@end
