//
//  PurchaseManager.h
//  HeatMoment
//
//  Created by Denny Kwon on 11/15/12.
//  Copyright (c) 2012 Teju Prasad. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <StoreKit/StoreKit.h>
#import "ReceiptCheck.h"

@protocol PurchaseManagerDelegate <NSObject>
- (void)productListReady;
- (void)purchaseFailed:(NSError *)error;
- (void)purchaseComplete:(BOOL)confirmation productID:(NSString *)pId reciept:(NSDictionary *)d;
@end


@interface PurchaseManager : NSObject <SKPaymentTransactionObserver, SKRequestDelegate, SKProductsRequestDelegate> {
    BOOL purchasing;
}

@property (assign) id delegate;
@property (retain, nonatomic) NSArray *SKProductsArray;
@property (retain, nonatomic) SKProductsRequest *productsRequest;
+ (PurchaseManager *)manager;
- (void)getProductList:(NSArray *)list;
- (void)purchase:(SKProduct *)prod;
@end
