//
//  BRTrackCell.m
//  ButterflySDK
//
//  Created by Denny Kwon on 12/3/12.
//  Copyright (c) 2012 ButterflyRadio. All rights reserved.
//

#import "BRTrackCell.h"

@implementation BRTrackCell
@synthesize btnComments;
@synthesize lblPrice;


- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.selectionStyle = UITableViewCellSelectionStyleGray;
        self.textLabel.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
        self.textLabel.textColor = [UIColor colorWithRed:136.0f/255.0f green:0.0f/255.0f blue:0.0f/255.0f alpha:1.0f]; //red
        self.textLabel.shadowColor = [UIColor whiteColor];
        self.textLabel.shadowOffset = CGSizeMake(-0.5f, 0.5f);
        self.textLabel.backgroundColor = [UIColor clearColor];
        self.detailTextLabel.numberOfLines = 2;
        self.detailTextLabel.font = [UIFont systemFontOfSize:10.0f];
        self.detailTextLabel.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (void)setup
{
    CGFloat w = 80.0f;
    lblPrice = [[UILabel alloc] initWithFrame:CGRectMake(self.contentView.frame.size.width-w-30, 32, w, 8)];
    lblPrice.text = @"";
    lblPrice.font = self.detailTextLabel.font;
    lblPrice.backgroundColor = [UIColor clearColor];
    lblPrice.textColor = self.detailTextLabel.textColor;
    lblPrice.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:lblPrice];
    
    self.btnComments = [UIButton buttonWithType:UIButtonTypeCustom];
    [self.btnComments setContentHorizontalAlignment:UIControlContentHorizontalAlignmentRight];
    [self.btnComments addTarget:self action:@selector(btnCommentsAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.btnComments setTitleColor:[UIColor colorWithRed:136.0f/255.0f green:0.0f/255.0f blue:0.0f/255.0f alpha:1.0f] forState:UIControlStateNormal];
    
    self.btnComments.titleLabel.font = [UIFont fontWithName:@"Heiti SC" size:10.0f];
    
    self.btnComments.frame = CGRectMake(self.frame.size.width-w-30, lblPrice.frame.origin.y+lblPrice.frame.size.height, w, 20);
    [self.contentView addSubview:self.btnComments];
}

- (void)dealloc
{
    [btnComments release];
    [lblPrice release];
    [super dealloc];
}


- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
