//
//  BRTextCell.m
//  ButterflySDK
//
//  Created by Denny Kwon on 4/10/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.
//

#import "BRTextCell.h"

#define kHeight 36.0f
@implementation BRTextCell
@synthesize textField;
@synthesize textMode;
@synthesize textView;

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.selectionStyle = UITableViewCellSelectionStyleNone;
        self.backgroundView = [[[UIImageView alloc] initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)] autorelease];
        self.selectionStyle = UITableViewCellSelectionStyleNone;
    }
    return self;
}

- (void)dealloc
{
    self.textField.delegate = nil;
    self.textField = nil;
    
    self.textView.delegate = nil;
    self.textView = nil;
    [super dealloc];
}

- (void)setup
{
    if (self.textMode==0){
        static CGFloat h = kHeight-8.0f;
        self.textField = [[[UITextField alloc] initWithFrame:CGRectMake(10.0f, 0.5*(self.contentView.frame.size.height-h)-3.0f, self.contentView.frame.size.width-30.0f, h)] autorelease];
        self.textField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        self.textField.backgroundColor = [UIColor clearColor];
        self.textField.font = [UIFont fontWithName:kFont size:14.0f];
        [self.contentView addSubview:self.textField];
        return;
    }
    
    self.textView = [[[UITextView alloc] initWithFrame:CGRectMake(3.0f, 2.0f, self.contentView.frame.size.width-26.0f, 76.0f)] autorelease];
    self.textView.text = @"Description";
    self.textView.textColor = [UIColor lightGrayColor];
    self.textView.backgroundColor = [UIColor clearColor];
    self.textView.font = [UIFont fontWithName:kFont size:14.0f];
    [self.contentView addSubview:self.textView];
    
}

+ (CGFloat)cellHeight
{
    return kHeight;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
}

@end
