//
//  RecordView.m
//  butterflyradio
//
//  Created by Denny Kwon on 4/7/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "RecordView.h"

//static NSString *play = @"play";
//static NSString *stop = @"stop";
//static NSString *record = @"record";
//static NSString *submit = @"submit";
//static NSString *fileName = @"track.m4a";
//static NSString *clear = @"clear";
static NSString *kDescription = @"description (optional)";
static CGFloat kHeight = 35.0f;


@implementation RecordView
@synthesize delegate;
@synthesize titleField;
@synthesize tagsField;
@synthesize commentField;
@synthesize timeLabel;
@synthesize mainButton;
@synthesize authorField;
@synthesize valueLabel;
@synthesize btnDecrease;
@synthesize btnIncrease;
@synthesize value;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.value = 0;
        UIView *background = [[UIView alloc] initWithFrame:CGRectMake(0, 0, frame.size.width, kHeight)];
        background.backgroundColor = [UIColor colorWithRed:kRGBMax/kRGBMax green:kRGBMax/kRGBMax blue:210.0f/kRGBMax alpha:1.0f];
        UIView *line = [[UIView alloc] initWithFrame:CGRectMake(0, background.frame.size.height-1, background.frame.size.width, 1)];
        line.backgroundColor = [UIColor darkGrayColor];
        [background addSubview:line];
        [line release];

        titleField = [[UITextField alloc] initWithFrame:CGRectMake(10, 5, 300, kHeight-10)];
        self.titleField.tag = 1000;
        self.titleField.autocorrectionType = UITextAutocorrectionTypeNo;
        self.titleField.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
        self.titleField.borderStyle = UITextBorderStyleNone;
        self.titleField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        self.titleField.delegate = self;
        self.titleField.placeholder = @"title";
        [background addSubview:self.titleField];
        [self addSubview:background];
        [background release];

        background = [[UIView alloc] initWithFrame:CGRectMake(0, 35, 320, kHeight)];
        background.backgroundColor = [UIColor colorWithRed:kRGBMax/kRGBMax green:kRGBMax/kRGBMax blue:210.0f/kRGBMax alpha:1.0f];
        line = [[UIView alloc] initWithFrame:CGRectMake(0, background.frame.size.height-1, background.frame.size.width, 1)];
        line.backgroundColor = [UIColor darkGrayColor];
        [background addSubview:line];
        [line release];
        
        authorField = [[UITextField alloc] initWithFrame:titleField.frame];
        self.authorField.tag = 1000;
        self.authorField.autocorrectionType = UITextAutocorrectionTypeNo;
        self.authorField.borderStyle = titleField.borderStyle;
        self.authorField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        self.authorField.font = titleField.font;
        self.authorField.delegate = self;
        self.authorField.placeholder = @"from";
        [background addSubview:self.authorField];
        [self addSubview:background];

        background = [[UIView alloc] initWithFrame:CGRectMake(0, 70, 320, kHeight)];
        background.backgroundColor = [UIColor colorWithRed:kRGBMax/kRGBMax green:kRGBMax/kRGBMax blue:210.0f/kRGBMax alpha:1.0f];
        line = [[UIView alloc] initWithFrame:CGRectMake(0, background.frame.size.height-1, background.frame.size.width, 1)];
        line.backgroundColor = [UIColor darkGrayColor];
        [background addSubview:line];
        [line release];
        
        tagsField = [[UITextField alloc] initWithFrame:titleField.frame];
        self.tagsField.tag = 1000;
        self.tagsField.autocorrectionType = UITextAutocorrectionTypeNo;
        self.tagsField.borderStyle = titleField.borderStyle;
        self.tagsField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
        self.tagsField.font = titleField.font;
        self.tagsField.delegate = self;
        self.tagsField.placeholder = @"tags (separated by commas)";
        [background addSubview:self.tagsField];
        
        [self addSubview:background];
        [background release];

        commentField = [[UITextView alloc] initWithFrame:CGRectMake(5, 105, 310, 165)];
        self.commentField.delegate = self;
        self.commentField.returnKeyType = UIReturnKeyDone;
        self.commentField.tag = 1000;
        self.commentField.backgroundColor = [UIColor clearColor];
        self.commentField.textColor = [UIColor lightGrayColor];
        self.commentField.text = kDescription;
        self.commentField.font = titleField.font;
        self.commentField.delegate = self;
        [self addSubview:self.commentField];
        
        UIImage *shadow = [UIImage imageNamed:@"dropShadow.png"];
        UIImageView *dropShadow = [[UIImageView alloc] initWithImage:shadow];
        dropShadow.frame = CGRectMake(0, commentField.frame.origin.y, shadow.size.width, shadow.size.height);
        [self addSubview:dropShadow];
        [dropShadow release];

        frame = commentField.frame;
        
        valueLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, frame.origin.y+frame.size.height, self.frame.size.width, 30.0f)];
        self.valueLabel.backgroundColor = [UIColor clearColor];
        self.valueLabel.font = [UIFont fontWithName:kFont size:16.0f];
        self.valueLabel.textColor = [UIColor darkGrayColor];
        self.valueLabel.textAlignment = NSTextAlignmentCenter;
        self.valueLabel.text = @"value: 0 tickets";
        [self addSubview:self.valueLabel];
        
        
        frame.origin.y = self.frame.size.height-210.0f;
        frame.size.height = 30.0f;
        timeLabel = [[UILabel alloc] initWithFrame:frame];
        self.timeLabel.font = [UIFont fontWithName:@"Heiti SC" size:18.0f];
        self.timeLabel.backgroundColor = [UIColor clearColor];
        self.timeLabel.textAlignment = UITextAlignmentCenter;
        self.timeLabel.textColor = [UIColor darkGrayColor];
        self.timeLabel.text = [NSString stringWithFormat:@"%@", kMaxTime];
        [self addSubview:self.timeLabel];
        
        self.mainButton = [UIButton buttonWithType:UIButtonTypeCustom];
        self.mainButton.showsTouchWhenHighlighted = YES;
        [self.mainButton setBackgroundImage:[UIImage imageNamed:@"btRecord@2x.png"] forState:UIControlStateNormal];
        CGFloat width = 70.0f;
        self.mainButton.frame = CGRectMake(0.5*(self.frame.size.width-width), timeLabel.frame.origin.y+timeLabel.frame.size.height, width, width);
        [self.mainButton addTarget:self action:@selector(mainButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:self.mainButton];
        
        width = 40.0f;
        self.btnDecrease = [UIButton buttonWithType:UIButtonTypeRoundedRect];
        self.btnDecrease.frame = CGRectMake(20, self.mainButton.frame.origin.y+15, width, width);
        [self.btnDecrease setTitle:@"-" forState:UIControlStateNormal];
        [self.btnDecrease addTarget:self action:@selector(btnValueTapped:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:self.btnDecrease];
        
        self.btnIncrease = [UIButton buttonWithType:UIButtonTypeRoundedRect];
        self.btnIncrease.frame = CGRectMake(self.frame.size.width-width-20, self.mainButton.frame.origin.y+15, width, width);
        [self.btnIncrease setTitle:@"+" forState:UIControlStateNormal];
        [self.btnIncrease addTarget:self action:@selector(btnValueTapped:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:self.btnIncrease];

    }
    return self;
}


- (void)dealloc
{
    self.valueLabel = nil;
    self.btnDecrease = nil;
    self.btnIncrease = nil;
    [titleField release];
    [tagsField release];
    [commentField release];
    [timeLabel release];
    [mainButton release];
    [authorField release];
    [super dealloc];
}

- (void)setViewMode:(BOOL)premium
{
    if (!premium){
        self.valueLabel.hidden = YES;
        self.btnIncrease.hidden = YES;
        self.btnDecrease.hidden = YES;
    }
}

- (void)exit
{
    [delegate exit];
}

- (void)showRadio
{
    [delegate showRadio];
}

- (void)setBtnImage:(UIImage *)img
{
    [mainButton setBackgroundImage:img forState:UIControlStateNormal];
}

- (void)clear
{
    self.timeLabel.text = [NSString stringWithFormat:@"%@", kMaxTime];
    self.commentField.textColor = [UIColor lightGrayColor];
    self.commentField.text = kDescription;
    self.tagsField.text = nil;
    self.titleField.text = nil;
    self.authorField.text = nil;
    self.valueLabel.text = @"value: 0 tickets";
}

- (void)updateValueLabel:(int)v
{
    self.valueLabel.text = [NSString stringWithFormat:@"value: %d tickets", v];
}

- (void)btnValueTapped:(UIButton *)btn
{
    CGFloat x = btn.frame.origin.x;
    (x < 0.5*self.frame.size.width) ? value-- : value++;
    if (value<0)
        value = 0;
    
    if (value>20)
        value = 20;
    
    [self updateValueLabel:value];
}

- (void)activateUploadButton
{
    
}


- (void)mainButtonPressed:(UIButton *)btn
{
    [delegate mainbtnPressed];
}

- (void)updateTimeLabel:(int)timeLeft
{
    if (timeLeft <= 30)
        self.backgroundColor = [UIColor redColor];

    float m = timeLeft/60;
    int mins = (int)m;
    int s = timeLeft % 60;
    
    NSString *seconds = (s < 10) ? [NSString stringWithFormat:@"0%d", s] : [NSString stringWithFormat:@"%d", s];
    self.timeLabel.text = [NSString stringWithFormat:@"time - %d:%@", mins, seconds];
}

#pragma mark - UITextFieldDelegate
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    [self.delegate updateTrackInfo:textField];
    return TRUE;
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string   // return NO to not change text
{
    [self.delegate updateTrackInfo:textField];
    return YES;
}

#pragma mark - UITextViewDelegate
- (void)textViewDidBeginEditing:(UITextView *)textView
{
    NSLog(@"textViewDidBeginEditing:");
    commentField.textColor = [UIColor blackColor];
    if ([commentField.text isEqualToString:kDescription]){
        commentField.text = @"";
    }
}

- (void)textViewDidEndEditing:(UITextView *)textView
{
    NSLog(@"textViewDidEndEditing:");
    if ([commentField.text length]==0){
        commentField.textColor = [UIColor lightGrayColor];
        commentField.text = kDescription;
    }
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text
{
    BOOL confirmation = TRUE;
    if ([text isEqualToString:@"\n"]){
        confirmation = FALSE;
        [commentField resignFirstResponder];
    }
    [self.delegate updateTrackInfo:textView];
    return confirmation;
}

#pragma mark - TouchEvents
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *t = [touches anyObject];
    UIView *view = [t view];
    if (view.tag!=1000){
        [commentField resignFirstResponder];
        [titleField resignFirstResponder];
        [tagsField resignFirstResponder];
    }
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}



/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end
