//
//  BRRedditViewController.m
//  ButterflySDK
//
//  Created by Denny Kwon on 1/25/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.
//

#import "BRRedditViewController.h"

@interface BRRedditViewController ()
@property (retain, nonatomic) UIWebView *theWebview;
@end

@implementation BRRedditViewController
@synthesize track;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        
    }
    return self;
}

- (void)dealloc
{
    self.theWebview = nil;
    self.track = nil;
    [super dealloc];
}

- (void)loadView
{
    CGRect frame = [UIScreen mainScreen].applicationFrame;
    UIView *view = [[UIView alloc] initWithFrame:frame];
    view.backgroundColor = [UIColor blackColor];
    view.autoresizingMask = UIViewAutoresizingFlexibleHeight;
    
    CGFloat height = 44.0f;
    frame.origin.y = 0.0f;
    frame.size.height -= height; //leave room for gradient bar
    self.theWebview = [[[UIWebView alloc] initWithFrame:frame] autorelease];
    self.theWebview.delegate = self;
    self.theWebview.scalesPageToFit = YES;
    [view addSubview:self.theWebview];
    
    UIToolbar *toolbar = [[UIToolbar alloc] initWithFrame:CGRectMake(0, view.frame.size.height-height+1, view.frame.size.width, height)];
    toolbar.barStyle = UIBarStyleBlack;
    toolbar.translucent = YES;
    toolbar.autoresizingMask = (UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleTopMargin);
    
    NSArray *barButtons = @[[self flex], [self barButtonWithImage:[UIImage imageNamed:@"toolbarClear.png"] tag:1001], [self flex], [self barButtonWithImage:[UIImage imageNamed:@"toolbarBack.png"] tag:1002], [self flex], [self barButtonWithImage:[UIImage imageNamed:@"toolbarNext.png"] tag:1003], [self flex]];
    
    toolbar.items = barButtons;
    [view addSubview:toolbar];
    [toolbar release];

    
    self.view = view;
    [view release];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setupLoadingIndicator];
    
    NSString *title = [track.name urlencode];
    NSString *urlString = ([self.track threadUrl]==nil) ? @"http://i.reddit.com/submit" : [NSString stringWithFormat:@"http://i.reddit.com/submit?title=%@&url=%@", title, [self.track threadUrl]];
    
    NSLog(@"URL STRING: %@", urlString);
    
    [self.theWebview loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:urlString]]];
    [self.loading show];
}

- (void)barButtonTapped:(UIBarButtonItem *)btn
{
    if (btn.tag==1001){
        [self dismissViewControllerAnimated:YES completion:NULL];
    }
    if (btn.tag==1002){
        [self.theWebview goBack];
    }
    if (btn.tag==1003){
        [self.theWebview goForward];
    }
}


#pragma mark - UIWebViewDelegate
- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
    NSLog(@"webView shouldStartLoadWithRequest: %@", request.URL.absoluteString);
    if (self.loading.hidden)
        [self.loading show];
    
    return YES;
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
    NSLog(@"webViewDidStartLoad:");
    
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    NSLog(@"webViewDidFinishLoad:");
    if (self.loading.hidden==NO)
        [self.loading hide];
}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
    NSLog(@"webView didFailLoadWithError:");
    if (self.loading.hidden==NO)
        [self.loading hide];

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

@end
