//
//  BRContentCell.m
//  ButterflySDK
//
//  Created by Denny Kwon on 1/12/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.
//

#import "BRContentCell.h"

@implementation BRContentCell
@synthesize btnReply;
@synthesize delegate;
@synthesize lblPrice;
@synthesize lblAuthorized;

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.selectionStyle = UITableViewCellSelectionStyleGray;
        self.textLabel.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
        self.textLabel.textColor = kBRRed;
        self.textLabel.shadowColor = [UIColor whiteColor];
        self.textLabel.shadowOffset = CGSizeMake(-0.5f, 0.5f);
        self.textLabel.backgroundColor = [UIColor clearColor];
        
        self.detailTextLabel.numberOfLines = 2;
        self.detailTextLabel.font = [UIFont systemFontOfSize:10.0f];
        self.detailTextLabel.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (void)dealloc
{
    self.btnReply = nil;
    self.delegate = nil;
    self.lblAuthorized = nil;
    [lblPrice release];
    [super dealloc];
}

- (void)setup
{
    CGFloat w = 80.0f;
    lblPrice = [[UILabel alloc] initWithFrame:CGRectMake(self.contentView.frame.size.width-w-30.0f, 32.0f, w, 8.0f)];
    self.lblPrice.text = @"";
    self.lblPrice.font = self.detailTextLabel.font;
    self.lblPrice.backgroundColor = [UIColor clearColor];
    self.lblPrice.textColor = self.detailTextLabel.textColor;
    self.lblPrice.textAlignment = NSTextAlignmentRight;
    [self.contentView addSubview:self.lblPrice];
    
    self.lblAuthorized = [[[UILabel alloc] initWithFrame:CGRectMake(180.0f, 40.0f, 80.0f, 15.0f)] autorelease];
    self.lblAuthorized.text = @"Authorized";
    self.lblAuthorized.textAlignment = NSTextAlignmentRight;
    self.lblAuthorized.font = [UIFont fontWithName:@"Heiti SC" size:10.0f];
    self.lblAuthorized.backgroundColor = [UIColor clearColor];
    self.lblAuthorized.textColor = [UIColor blackColor];
    [self.contentView addSubview:self.lblAuthorized];
    
    UIImage *imgReply = [UIImage imageNamed:@"btn_reply.png"];
    self.btnReply = [UIButton buttonWithType:UIButtonTypeCustom];
    [self.btnReply setBackgroundImage:imgReply forState:UIControlStateNormal];
    [self.btnReply setContentHorizontalAlignment:UIControlContentHorizontalAlignmentCenter];
    [self.btnReply addTarget:self action:@selector(btnReplyAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.btnReply setTitleColor:kBRRed forState:UIControlStateNormal];
    self.btnReply.titleLabel.font = [UIFont fontWithName:@"Heiti SC" size:10.0f];
    [self.btnReply setTitle:@"reply" forState:UIControlStateNormal];
    w = imgReply.size.width;
    self.btnReply.frame = CGRectMake(self.frame.size.width-w-10, 30.0f, w, imgReply.size.height);
    [self.contentView addSubview:self.btnReply];
}

- (void)btnReplyAction:(UIButton *)btn
{
    if ([self.delegate respondsToSelector:@selector(cellTapped:)])
        [self.delegate cellTapped:self.tag];
}

- (void)clear:(NSString *)message
{
    self.textLabel.text = message;
    self.detailTextLabel.text = @"";
    self.lblPrice.text = @"";
    self.lblAuthorized.hidden = YES;
    self.btnReply.hidden = YES;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
