//
//  BRStationInfoView.m
//  ButterflySDK
//
//  Created by Denny Kwon on 1/13/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.
//

#import "BRStationInfoView.h"
#import "Globals.h"
#import <QuartzCore/QuartzCore.h>

@implementation BRStationInfoView
@synthesize lblName;
@synthesize lblCategory;
@synthesize lblTracks;
@synthesize lblAdmins;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        self.backgroundColor = [UIColor clearColor];
        
        lblName = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, frame.size.width, 25)];
        self.lblName.layer.cornerRadius = 1.0f;
        self.lblName.backgroundColor = [UIColor clearColor];
        self.lblName.textAlignment = NSTextAlignmentRight;
        self.lblName.textColor = kBRRed;
        self.lblName.font = [UIFont fontWithName:kFont size:16.0f];
        self.lblName.minimumFontSize = 10.0f;
        [self addSubview:self.lblName];
        
        CGFloat y = 30.0f;
        CGFloat h = 18.0f;
        CGFloat shadowOffset = 1.5f;
        
        UIView *background = [[UIView alloc] initWithFrame:CGRectMake(0.0f, y, frame.size.width-shadowOffset, frame.size.height-y)];
        background.backgroundColor = [UIColor colorWithRed:0.8f green:0.8f blue:0.8f alpha:1.0f];
        [self addSubview:background];
        [background release];
        
        background = [[UIView alloc] initWithFrame:CGRectMake(shadowOffset, y-shadowOffset, frame.size.width-shadowOffset, frame.size.height-y)];
        background.backgroundColor = [UIColor whiteColor];
        [self addSubview:background];
        [background release];

        y += 4.0f;
        
        self.lblCategory = [self labelWithFrame:CGRectMake(0, y, frame.size.width-5, h)];
        [self addSubview:self.lblCategory];
        
        y += h;
        self.lblTracks = [self labelWithFrame:CGRectMake(0, y, frame.size.width-5, h)];
        [self addSubview:self.lblTracks];

        y += h;
        self.lblAdmins = [self labelWithFrame:CGRectMake(0, y, frame.size.width-5, h)];
        [self addSubview:self.lblAdmins];
    }
    return self;
}

- (void)dealloc
{
    self.lblCategory = nil;
    self.lblName = nil;
    self.lblTracks = nil;
    self.lblAdmins = nil;
    [super dealloc];
}

- (UILabel *)labelWithFrame:(CGRect)frame
{
    UILabel *label = [[UILabel alloc] initWithFrame:frame];
    label.textAlignment = NSTextAlignmentRight;
    label.textColor = [UIColor darkGrayColor];
    label.backgroundColor = [UIColor clearColor];
    label.font = [UIFont fontWithName:kFont size:12.0f];
    return [label autorelease];
}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end
