//
//  Station.h
//  butterflyradio
//
//  Created by Denny Kwon on 4/3/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Globals.h"
#import "GetImage.h"
#import "Globals.h"
#import "Article.h"
#import "JSON.h"
#import "Database.h"
#import "BRNetworkOp.h"
#import "Thread.h"
#import "BRTrack.h"
#import "XMLParser.h"



@protocol StationDelegate <NSObject>
@optional
- (void)imageReady:(NSString *)stationId;
- (void)thumbnailDownloaded:(NSString *)stationId;
- (void)stationInfoReady:(NSString *)stationId;
- (void)podcastTracksReady;
@end

@interface Station : NSObject <BRNetworkOpDelegate, XMLParserDelegate> {
    NSOperationQueue *queue;
    GetImage *getImage;
    GetImage *getThumb;
}

@property (assign) id delegate;
@property (nonatomic) int adFreq;
@property (nonatomic) BOOL ready;
@property (nonatomic) BOOL saved;
@property (copy, nonatomic) NSString *name;
@property (copy, nonatomic) NSString *host;
@property (copy, nonatomic) NSString *unique_id;
@property (copy, nonatomic) NSString *description;
@property (copy, nonatomic) NSString *category;
@property (copy, nonatomic) NSString *image;
@property (copy, nonatomic) NSString *podcastRss;
@property (retain, nonatomic) NSArray *tags;
@property (retain, nonatomic) NSArray *admins;
@property (retain, nonatomic) NSMutableArray *tracks;
@property (retain, nonatomic) NSMutableArray *premiumTracks;
@property (retain, nonatomic) NSMutableArray *articles;
@property (retain, nonatomic) NSMutableArray *threadArray;
@property (retain, nonatomic) NSMutableArray *podcastTracks;
@property (retain, nonatomic) NSMutableDictionary *threadMap;
@property (nonatomic) long long plays;
@property (retain, nonatomic) NSData *imgData;
@property (retain, nonatomic) UIImage *thumbnail;
@property (retain, nonatomic) BRNetworkOp *request;
@property (retain, nonatomic) XMLParser *xmlParser;

+ (Station *)stationWithInfo:(NSDictionary *)info;
- (void)getStationInfo;
- (void)populate:(NSDictionary *)info;
- (void)fetchImage;
- (void)fetchThumbnail:(int)dimen;
- (NSString *)adminsString;
- (void)save;
- (void)deleteFromDb;
- (NSString *)tagsString;
- (void)cancelUpdate;
- (void)checkDatabase;
- (void)downloadPodcast;
@end