//
//  BRGradientBar.h
//  ButterflySDK
//
//  Created by Denny Kwon on 1/19/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol GradientBarDelegate <NSObject>
- (void)btnGradientTapped:(UIButton *)btn;
- (void)gradientBarMoved:(double)diff;
- (void)gradientBarStopped;
- (void)swipe:(double)direction;
@end

@interface BRGradientBar : UIView

@property (retain, nonatomic) UILabel *lblTitle;
@property (retain, nonatomic) UIButton *btnToggle;
@property (nonatomic) BOOL moveable;
@property (assign) id delegate;
+ (BRGradientBar *)barWithFrame:(CGRect)frame;
+ (BRGradientBar *)barWithFrame:(CGRect)frame background:(UIColor *)bg;
- (void)rotateButton:(CGAffineTransform)orientation;
@end
