//
//  BRTextBox.m
//  butterflyradio
//
//  Created by Denny Kwon on 5/12/13.
//  Copyright (c) 2013 com.thegridmedia. All rights reserved.
//

#import "BRTextBox.h"

@implementation BRTextBox
@synthesize lblText;
@synthesize bgGray;
@synthesize bgWhite;
@synthesize lblTitle;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        self.backgroundColor = [UIColor clearColor];
        
        CGFloat offset = 2.0f;
        self.bgGray = [[[UIView alloc] initWithFrame:CGRectMake(0.0f, offset, frame.size.width-offset, frame.size.height-offset)] autorelease];
        self.bgGray.backgroundColor = [UIColor lightGrayColor];
        [self addSubview:self.bgGray];
        
        self.bgWhite = [[[UIView alloc] initWithFrame:CGRectMake(offset, 0.0f, frame.size.width-offset, frame.size.height-offset)] autorelease];
        self.bgWhite.backgroundColor = [UIColor whiteColor];
        [self addSubview:self.bgWhite];
        
        self.lblTitle = [[[UILabel alloc] initWithFrame:CGRectMake(0.0f, 7.0f, frame.size.width, 20.0f)] autorelease];
        self.lblTitle.backgroundColor = [UIColor clearColor];
        self.lblTitle.textColor = kBRRed;
        self.lblTitle.textAlignment = NSTextAlignmentCenter;
        [self addSubview:self.lblTitle];
        
        
        self.lblText = [[[UILabel alloc] initWithFrame:CGRectMake(0.0f, 25.0f, frame.size.width, 15.0f)] autorelease];
        self.lblText.backgroundColor = [UIColor clearColor];
        self.lblText.numberOfLines = 0;
        self.lblText.textColor = [UIColor darkGrayColor];
        self.lblText.font = [UIFont fontWithName:@"Heiti SC" size:14.0f];
        self.lblText.lineBreakMode = UILineBreakModeWordWrap;
        self.lblText.textAlignment = NSTextAlignmentCenter;
        [self addSubview:self.lblText];
        
        [self.lblText addObserver:self forKeyPath:@"text" options:0 context:nil];
    }
    return self;
}

- (void)dealloc
{
    [self.lblText removeObserver:self forKeyPath:@"text"];
    
    self.lblText = nil;
    self.lblTitle = nil;
    self.bgGray = nil;
    self.bgWhite = nil;
    [super dealloc];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    if (![object isEqual:self.lblText])
        return;
    
    if (![keyPath isEqualToString:@"text"])
        return;
    
//    NSLog(@"observeValueForKeyPath: %@", keyPath);
    
    CGFloat padding = 10.0f;
    CGFloat maxWidth = self.frame.size.width-2*padding;
    
    CGSize size = [self.lblText.text sizeWithFont:self.lblText.font
                   constrainedToSize:CGSizeMake(maxWidth, 300.0f)
                       lineBreakMode:self.lblText.lineBreakMode];
    
    CGFloat y = self.lblText.frame.origin.y;
    self.lblText.frame = CGRectMake(padding, padding+y, maxWidth, size.height);
    
    CGRect frame = self.frame;
    CGFloat height = size.height+2*padding+y;
    
    frame.size.height = height;
    self.frame = frame;
    
    frame = self.bgWhite.frame;
    frame.size.height = height;
    self.bgWhite.frame = frame;
    
    frame = self.bgGray.frame;
    frame.size.height = height;
    self.bgGray.frame = frame;
}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end

