//
//  BRToolbar.m
//  ButterflySDK
//
//  Created by Denny Kwon on 2/27/13.
//  Copyright (c) 2013 ButterflyRadio. All rights reserved.


#import "BRToolbar.h"

@implementation BRToolbar
@synthesize lblAccount;
@synthesize lblTickets;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.barStyle = UIBarStyleBlack;
        self.translucent = YES;

        CGFloat w = 0.5f*frame.size.width;
        CGFloat h = 10.0f;
        self.lblAccount = [[[UILabel alloc] initWithFrame:CGRectMake(0.0f, 0.0f, w, h)] autorelease];
        self.lblAccount.backgroundColor = [UIColor blackColor];
        self.lblAccount.alpha = 0.6f;
        self.lblAccount.textColor = [UIColor whiteColor];
        self.lblAccount.textAlignment = NSTextAlignmentCenter;
        self.lblAccount.font = [UIFont systemFontOfSize:h];
        self.lblAccount.text = @"account: logged out";
        [self addSubview:self.lblAccount];
        
        self.lblTickets = [[[UILabel alloc] initWithFrame:CGRectMake(w, 0.0f, w, h)] autorelease];
        self.lblTickets.backgroundColor = [UIColor blackColor];
        self.lblTickets.alpha = 0.6f;
        self.lblTickets.textColor = [UIColor whiteColor];
        self.lblTickets.textAlignment = NSTextAlignmentCenter;
        self.lblTickets.font = [UIFont systemFontOfSize:h];
        self.lblTickets.text = @"tickets: 0";
        [self addSubview:self.lblTickets];
        
    }
    return self;
}

+ (BRToolbar *)toolbar:(CGRect)frame withItems:(NSArray *)items
{
    BRToolbar *toolbar = [[BRToolbar alloc] initWithFrame:frame];
    toolbar.autoresizingMask = (UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleTopMargin);
    toolbar.items = items;
    return [toolbar autorelease];
}

- (void)dealloc
{
    self.lblTickets = nil;
    self.lblAccount = nil;
    [super dealloc];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end
