//  GetImage.m
//  Copyright 2011 __MyCompanyName__. All rights reserved.

#import "GetImage.h"

@implementation GetImage
@synthesize address;

- (id)initWithTarget:(id)t address:(NSString *)a action:(SEL)cbk
{
    self = [super init];
    if (self){
        target = t;
        action = cbk;
        filter = StationSearchFilterTop;
        address = [a retain];
    }
    return  self;
}

- (id)initWithTarget:(id)t address:(NSString *)a action:(SEL)cbk filter:(BRStationSearchFilter)f
{
    self = [super init];
    if (self){
        target = t;
        action = cbk;
        filter = f;
        address = [a retain];
    }
    return  self;
}

- (void)dealloc
{
    [address release];
    [super dealloc];
}

- (void)cancel
{
    NSLog(@"GET IMAGE CANCELLED!");
    [super cancel];
}

- (void)main
{
    NSLog(@"GET IMAGE: %@", address);
    NSData *imgData = [NSData dataWithContentsOfURL:[NSURL URLWithString:address]];
    if (!imgData){
        NSLog(@"GET IMAGE - Cancelling");
        [self cancel];
        return;
    }
    
    if ([self isCancelled])
        return;

    NSArray *pkg = [NSArray arrayWithObjects:address, imgData, nil];
    [target performSelectorOnMainThread:action withObject:pkg waitUntilDone:NO];

}

@end
